#include <minigui.ch>
//#include <adordd.ch>
#include <common.ch>

#translate ISNIL(  <xVal> ) => ( <xVal> == NIL )
#translate ISARRY( <xVal> ) => ( VALTYPE( <xVal> ) == "A" )
#translate ISCHAR( <xVal> ) => ( VALTYPE( <xVal> ) == "C" )
#translate ISNUMB( <xVal> ) => ( VALTYPE( <xVal> ) == "N" )
#xcommand DEFAULT <v1> TO <x1> [, <vn> TO <xn> ]                        ;
          =>                                                            ;
          IF <v1> == NIL ; <v1> := <x1> ; END                           ;
          [; IF <vn> == NIL ; <vn> := <xn> ; END ]
          
declare window walert
*-----------------------------------*

FUNCTION walert( cMessage, aItems, cTitle )
	LOCAL I:=0 , J:=0 , nStart:=1 , nValue:=0
	local nHeight
	
	DEFAULT aItems TO {}
	DEFAULT cMessage TO ' '

	if isWindowDefined("WALERT")
		Walert.Release
	endif
	
	IF SET( _SET_LANGUAGE )=='POLISH'
		DEFAULT cTitle TO 'Wybr...'
	ELSE
		DEFAULT cTitle TO 'Please, select'
	ENDIF
	
	// 250 - minimal height 
	nHeight := max( MLCount(cMessage,50,8,.t.)*20 + 10+25 + 30+10, 250)
	
	nItemCount := len(aItems)
	if nItemCount < 2
		// one button on center of the window
		nStart := 160
	else
		// 80 - width of Button
		// 20 - space between buttons
		// 200 half of width of walert window
		nStart := 200 - (nItemCount*80 + (nItemCount-1)*20)/2
	endif
	
	
	DEFINE WINDOW WALERT ;
		AT 0,0 ;
		WIDTH 400 HEIGHT nHeight ;
		TITLE cTitle ;
		ICON 'MAIN' ;
		MODAL ;
		NOSIZE 
	
	
	//******************** DISPLAY MESSAGE *******************************
	FOR i:=1 TO MLCount(cMessage,50,8,.f.)
		cTexLabel := 'text'+str(i,1)
		@ (i*20)-10,016 LABEL &cTexLabel WIDTH 368 HEIGHT 20 VALUE MemoLine(cMessage, 50, i, 8, .t.) ;
			FONT 'ARIAL' SIZE 10 CENTERALIGN
	NEXT i

	//******************** DRAW BUTTONS ***********************************
	if nItemCount <= 1
		@ 150,160 BUTTON Button_1 ;
		CAPTION '&OK' ;
		ACTION {|| nValue := 0, walert.Release } ;
		WIDTH 80 HEIGHT 30
	else
		aBlocks := array(nItemCount)
		for i:=1 to nItemCount
			//bActionBlock :=("{ || nValue := " + str( i,1 )  + ", MsgBox(nValue),ThisWindow.Release }")
			//aBlocks[i] := &("{ || nValue := " + str( i,1 )  + ", MsgBox(STR(nValue)) } ")
			//EVAL(ABLOCKS[I])
			@ nHeight-60, nStart+100*(i-1) BUTTON &("Button_"+str(i,1)) ;
			CAPTION '&'+aItems[i] ;
			ACTION { || nValue := val(right(this.name,1)),walert.release} ;
			WIDTH 80 HEIGHT 30
			
		next i
	endif

	END WINDOW
	CENTER WINDOW walert
	ON KEY ESCAPE of WALERT ACTION walert.release
	ACTIVATE WINDOW walert
RETURN(nValue)
*---------------
function UstawFiltr(cBrowseName)

	private cCurrentWindow, cCurrentBrowse, LiczbaPol, i, aFields, aHeaders, cWorkArea
	private opcje := {      '    =', '   <>', '   <=', '   <', '   >=','   >','zawiera',' puste','niepuste'}
	private cTyp, nSysBrowse
	private aConditions := { }, aGridConditions := {}
	private DBFilterStatusBarItem := 1
	cCurrentWindow := thisWindow.name
	cCurrentBrowse := cBrowseName
	nSysBrowse := GetControlIndex ( cCurrentBrowse , cCurrentWindow )
	aFields := _HMG_SYSDATA [ 31 ] [nSysBrowse]
	aHeaders := _HMG_SYSDATA [ 33 ] [nSysBrowse]
	cWorkArea := _HMG_SYSDATA [ 22 ] [nSysBrowse]
		
	Load Window OknoWarunek
	ON KEY ESCAPE OF OknoWarunek ACTION OknoWarunek.Release

	ZmienOperatory()
	
	Center Window OknoWarunek
	Activate Window OknoWarunek
	// refreshing after setting filter or not...
	_BrowseRefresh(cCurrentBrowse,cCurrentWindow,nSysBrowse)
	
 return
 *-----------------------------------*

function ZmienOperatory
	private NumerPola := OknoWarunek.C_Pole.Value
	private czynnik1 := rtrim(aFields[numerpola])
	private  i
	
	cTyp := type(aFields[numerPola])
	
	do case
		case cTyp == "L"
			Opcje := {"Prawda","Fasz"}
			OknoWarunek.T_Czynnik2D.Visible := .f.
			OknoWarunek.T_Czynnik2C.Visible := .f.
			OknoWarunek.T_Czynnik2N.Visible := .f.
		case cTyp == "N"
			Opcje := {      '    =', '   <>', '   <=', '   <', '   >=','   >' }
			OknoWarunek.T_Czynnik2D.Visible := .f.
			OknoWarunek.T_Czynnik2C.Visible := .f.
			OknoWarunek.T_Czynnik2N.Visible := .t.
		case cTyp == "C" .or. cTyp == "M"
			Opcje := {      '    =', '   <>', '   <=', '   <', '   >=','   >','zawiera',' puste','niepuste'}
			OknoWarunek.T_Czynnik2D.Visible := .f.
			OknoWarunek.T_Czynnik2C.Visible := .t.
			OknoWarunek.T_Czynnik2N.Visible := .f.
		case cTyp == "D"
			Opcje := {      '    =', '   <>', '   <=', '   <', '   >=','   >' }
			OknoWarunek.T_Czynnik2D.Visible := .t.
			OknoWarunek.T_Czynnik2C.Visible := .f.
			OknoWarunek.T_Czynnik2N.Visible := .f.
	end case
	OknoWarunek.C_Operator.DeleteAllItems
	for i := 1 to len(Opcje)
		OknoWarunek.C_Operator.AddItem(Opcje[i])
	next i
	OknoWarunek.C_Operator.Value := 1
 return
*------------------------
function P_UstawFiltr
	local i, cCondition, cCondition2
	local abActions
	cCondition	:= ""
	cCondition2	:= ""
	for i :=1 to len(aConditions)
		// +1 because of  empty connector for which value in array is eq 0
		cCondition	+= aConditions[i,1] + {"",".and.",".or."} [ aGridConditions[i,2]+1 ]
		cCondition2	+= aGridConditions[i,1] + " " + {"","i","lub"} [ aGridConditions[i,2]+1 ] + " "
	next i
	if !empty(cCondition)
		select(cWorkArea)
		if !empty(DBFilter())
			// set filter additive to current filter
			cCondition	:= DBFilter()+".and."+cCondition
			cCondition2	:= DBFilter()+" i "+cCondition2
		endif
		set filter to &cCondition 
		go recno()
		skip -1
		skip 1
	endif
	
	// you need to define StatusBar in cCurrentWindow, otherwise it ganerates runtime error
	SetProperty(cCurrentWindow,"StatusBar","Item",DBFilterStatusBarItem, "FILTR" )
	// retrieve action for StatusBar actions
	i := GetControlIndex ( 'StatusBar' , cCurrentWindow )
	abActions := _HMG_SYSDATA [  6 ]   [i]
	if valtype(abActions) <> "A"
		// it won't happpen
		abActions := array(DBFilterStatusBarItem)
	elseif len(abActions) < DBFilterStatusBarItem
		// I think, it won't happen too
		abActions := asize( abActions, DBFilterStatusBarItem )
	endif
	// creating code block for first StatusBar Item
	abActions[ DBFilterStatusBarItem ] := &("{ || MsgBox('Zdefiniowano filtr na tabeli:" + chr(10) + cCondition2 + "' ) } ")
	_HMG_SYSDATA [  6 ]   [i] := abActions
	OknoWarunek.Release
 return
*------------------------		
function GetCondition
	parameters lokalizuj
	local lAddCondition := .t.
	private rob, rob2, wybor, dostepne[8], czynnik1, czynnik2, operator,;
					NrOperatora, PoleLogiczne, NumerPola
	private cCzynnik2 := "T_Czynnik2"+cTyp
	
	rob := ""
	rob2 := ""
	NumerPola	:= OknoWarunek.C_Pole.Value
	czynnik1	:= alltrim(aFields[numerpola])
	czynnik11	:= alltrim(aHeaders[numerPola])
	NrOperatora := OknoWarunek.C_Operator.Value
	if (NrOperatora)=0
		return
	endif

	if NrOperatora = 8
			rob += "empty("+czynnik1+")"
			rob2+= "puste("+czynnik11+")"
	elseif NrOperatora = 9
		rob += "!empty("+czynnik1+")"
		rob2 += "niepuste("+czynnik11+")"
	else
		operator  := if(NrOperatora=7,"$",ltrim(opcje[NrOperatora]))
		wybor := 1
		do case
			case wybor=1
				czynnik2	:= ConditionToStr(GetProperty("OknoWarunek",cCzynnik2,"Value"))
				czynnik21	:= GetProperty("OknoWarunek",cCzynnik2,"DisplayValue")
			case wybor=2
				//if Eval(BWyborPola) = 27
				//		exit
				//endif
				//czynnik2 := rtrim(aNazwyPol[NumerPola])
			case wybor=0
				//exit
		endcase
		if NrOperatora = 7
			* "zawiera - $"
			rob	+= czynnik2 + operator + czynnik1
			rob2+= czynnik21 + operator + czynnik11
		else
			if type(czynnik1) = "L" .and. wybor = 1
				if NrOperatora == 1
					rob += czynnik1
					rob2 += "TAK("+czynnik11+")"
				else
					rob += "!"+czynnik1
					rob2 += "NIE("+czynnik11+")"
				endif
			else
				rob += czynnik1 + operator + czynnik2
				rob2 += czynnik11 + " "+operator + " "+ czynnik21
			endif
		endif
	endif

	i := len(AConditions)
	lAddCondition := .t.
	if i>0
		nTypeOfConnector := walert("Wybierz cznik midzy warunkami",{"i","lub"},"Wybierz opcj")
		do case
			case nTypeOfConnector == 1
				AGridConditions[i,2] := 1	//"i"
				AConditions[i,2] := ".and."
			case nTypeOfConnector == 2
				AGridConditions[i,2] := 2	//"lub"
				AConditions[i,2] := ".or."
			otherwise
				lAddCondition := .f.
		endcase
	endif
	if lAddCondition
		AAdd(AConditions, {rob,""} )
		AAdd(AGridConditions, {rob2, 0} )
		OknoWarunek.P_UstawFiltr.Visible := .t.
	endif

	//refresh grid with conditions
	OknoWarunek.G_Conditions.DeleteAllItems()
	for i:=1 to len(AGridConditions)
		OknoWarunek.G_Conditions.AddItem(AGridCondItions[i])
	next i
 return rob

*-----------------------------------*
function  ConditionToStr
	parameters var
	private rob

	do case
		case type("var")="C"
			rob := '"'+rtrim(var)+'"'
		case type("var")="N"
			rob := ltrim(str(var))
		case type("var")="D"
			rob := 'ctod("'+dtoc(var)+'")'
		case type("var")="L"
			rob := if(var,".t.",".f.")
	endcase
 return rob
*------------------------------------
function DeleteCondition
	local i, cCondition
	
	i := OknoWarunek.G_Conditions.Value
	if i == 0
		return
	endif
	cCondition := aGridConditions[i,1]
	if !MsgYesNo("Rzeczywicie usun warunek: "+cCondition +"?","Potwierd usunicie",.t.)
		return
	endif
	
	DelArrayItem(aGridConditions,i)
	DelArrayItem(aConditions,i)
	OknoWarunek.G_Conditions.DeleteItem(i)
	if len(aGridConditions) == 0
		OknoWarunek.P_UstawFiltr.Visible := .f.
	else
		i := len(aGridConditions)
		// we must delete connector from last line
		aGridConditions[i, 2] := 0
		aConditions[i, 2] := ""
	endif
	//refresh grid with conditions
	OknoWarunek.G_Conditions.DeleteAllItems()
	for i:=1 to len(AGridConditions)
		OknoWarunek.G_Conditions.AddItem(AGridCondItions[i])
	next i
 return
*-------------------------------------
function DelArrayItem
	param aSource, nItem
	local x, nLen, aTemp
	
	nLen := len(aSource)
	aTemp := array(nLen - 1)
	for x:= nItem + 1 to nLen
		aSource[x-1] := aSource[x]
	next x
	aSize(aSource, nLen -1)
 return
 